proc book_init_var {org_id proj_id book_id}\
{
	global BOOK_FIELD_${org_id}_${proj_id}_${book_id}
	global BOOK_REC_${org_id}_${proj_id}_${book_id}
	global CUR_ID_${org_id}_${proj_id}_${book_id}
	global CUR_NUM_${org_id}_${proj_id}_${book_id}
	global TOT_NUM_${org_id}_${proj_id}_${book_id}
	set BOOK_FIELD_${org_id}_${proj_id}_${book_id} ""
	set BOOK_REC_${org_id}_${proj_id}_${book_id} ""
	set CUR_ID_${org_id}_${proj_id}_${book_id} 0
	set CUR_NUM_${org_id}_${proj_id}_${book_id} 1
	set TOT_NUM_${org_id}_${proj_id}_${book_id} 1
}

proc book_new_id {org_id proj_id}\
{
	global LIST_BOOK
	set book_id 0
	foreach b $LIST_BOOK \
	{
		if {[regexp "^${org_id}_${proj_id}_(\[0-9\]+)" $b all id]}\
		{
			if {$id > $book_id}\
			{
				set book_id $id
			}
		}
	}
	return [expr $book_id + 1]
}

proc book_d_new {org_id}\
{
	global FIELD_LIST proj IMG_PATH
	global CUR_ORG LIST_PROJ LIST_BOOK
	set FIELD_LIST ""
	catch {destroy .newbook}
	toplevel .newbook
	wm title .newbook "New book"
	wm geometry .newbook +50+50
	frame .newbook.b
	pack .newbook.b -side bottom -pady 5 -padx 5
		button .newbook.b.ok -text Ok -width 10 \
			-command {
				if {[.newbook.l.f3.lb size] == 0}\
				{
					return
				}
				set proj_id [join [lindex [split $proj ---] 0]]
				set book_id [book_new_id $CUR_ORG $proj_id]
				book_init_var $CUR_ORG $proj_id $book_id
				upvar #0 BOOK_REC_${CUR_ORG}_${proj_id}_${book_id} BOOK_REC
				set BOOK_REC ""
				upvar #0 BOOK_${CUR_ORG}_${proj_id}_${book_id} BOOK
				set BOOK ""
				if {[join [.newbook.name.e get]] == ""}\
				{
					keylset BOOK name "Untitled"
				}\
				else\
				{
					keylset BOOK name [.newbook.name.e get]
				}
				upvar #0 BOOK_FIELD_${CUR_ORG}_${proj_id}_${book_id} BOOK_FIELD
				set BOOK_FIELD ""
				set i 0
				if {$FIELD_LIST == ""}\
				{
					lappend FIELD_LIST "New field"
				}
				while {$i < [llength $FIELD_LIST]}\
				{
					set name [lindex $FIELD_LIST $i]
					keylset BOOK_FIELD f$i.name "$name"
					keylset BOOK_REC 1.f$i ""
					incr i
				}
				lappend LIST_BOOK ${CUR_ORG}_${proj_id}_${book_id}
				book_save $CUR_ORG $proj_id $book_id 0
				o_menu_compose $CUR_ORG
				destroy .newbook
			}
		pack .newbook.b.ok -side left
		button .newbook.b.cancel -text Cancel -width 10 \
			-command "
				destroy .newbook
			"
		pack .newbook.b.cancel -side left
	frame .newbook.name
	pack .newbook.name -fill x
		label .newbook.name.l -text "Book's name: "
		pack .newbook.name.l -side left
		entry .newbook.name.e
		pack .newbook.name.e -side left
	frame .newbook.l
	pack .newbook.l -side left -fill y -pady 5 -padx 5
		frame .newbook.l.f3
		pack .newbook.l.f3 -fill y
			scrollbar .newbook.l.f3.vs -command {.newbook.l.f3.lb yview}
			pack .newbook.l.f3.vs -side right -fill y
			listbox .newbook.l.f3.lb -width 30 -yscrollcommand {.newbook.l.f3.vs set}
			pack .newbook.l.f3.lb -side right -fill y
			foreach p $LIST_PROJ \
			{
				global PROJ_${org_id}_$p
				.newbook.l.f3.lb insert end "$p --- [keylget PROJ_${org_id}_$p name]"
			}
			.newbook.l.f3.lb selection set 0
			set proj [.newbook.l.f3.lb get 0]
			bind .newbook.l.f3.lb <1> {
				update
				set proj [.newbook.l.f3.lb get @%x,%y]
			}
	frame .newbook.m
	pack .newbook.m -side left -fill y -pady 5 -padx 5
		frame .newbook.m.f
		pack .newbook.m.f -side bottom -fill x
			button .newbook.m.f.down -bitmap @$IMG_PATH/down.bmp -width 16 -height 10 \
				-command {
					set selected [.newbook.r.lb curselection]
					if {$selected != "" && \
						$selected < [expr [llength $FIELD_LIST] - 1]}\
					{
						set f [lvarpop FIELD_LIST $selected]
						set FIELD_LIST [linsert $FIELD_LIST [expr $selected + 1] $f]
						.newbook.r.lb delete $selected
						set name [lindex [split $f -+=] 0]
						.newbook.r.lb insert [expr $selected + 1] $name
						.newbook.r.lb selection set [expr $selected + 1]
					}
				}
			pack .newbook.m.f.down -side bottom
			button .newbook.m.f.up -bitmap @$IMG_PATH/up.bmp -width 16 -height 10 \
				-command {
					set selected [.newbook.r.lb curselection]
					if {$selected != "" && \
						$selected > 0}\
					{
						set f [lvarpop FIELD_LIST $selected]
						set FIELD_LIST [linsert $FIELD_LIST [expr $selected - 1] $f]
						.newbook.r.lb delete $selected
						set name [lindex [split $f -+=] 0]
						.newbook.r.lb insert [expr $selected - 1] $name
						.newbook.r.lb selection set [expr $selected - 1]
					}
				}
			pack .newbook.m.f.up -side bottom
	frame .newbook.r
	pack .newbook.r -side left -pady 5 -padx 5
		frame .newbook.r.f1
		pack .newbook.r.f1 -side top
			label .newbook.r.f1.l -text "Field's name"
			pack .newbook.r.f1.l -side left
			entry .newbook.r.f1.e
			pack .newbook.r.f1.e -side left
		frame .newbook.r.f2
		pack .newbook.r.f2 -side top
			button .newbook.r.f2.add -text Add -width 8 \
				-command {
					if {[.newbook.r.f1.e get] != ""}\
					{
						.newbook.r.lb insert end "[.newbook.r.f1.e get]"
						lappend FIELD_LIST "[.newbook.r.f1.e get]"
						.newbook.r.f1.e delete 0 end
					}
				}
			pack .newbook.r.f2.add -side left
			button .newbook.r.f2.del -text Delete -width 8 \
				-command {
					set selected [.newbook.r.lb curselection]
					if {$selected != ""}\
					{
						.newbook.r.lb delete $selected
						lvarpop FIELD_LIST $selected
					}
				}
			pack .newbook.r.f2.del -side left
		scrollbar .newbook.r.vs -command {.newbook.r.lb yview}
		pack .newbook.r.vs -side right -fill y
		listbox .newbook.r.lb -yscrollcommand {.newbook.r.vs set}
		pack .newbook.r.lb -side top -fill both
	focus .newbook.r.f1.e
}

################################

proc book_import {org_id proj_id book_id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	global FILENAME FIELD_SEPARATOR
	o_wait
	if {$FIELD_SEPARATOR == ""}\
	{
		set FIELD_SEPARATOR "	"
	}
	set FIELD_SEPARATOR [cindex $FIELD_SEPARATOR 0]
	set F [open [pwd]/$FILENAME r]
	while {! [eof $F]}\
	{
		set line [gets $F]
		if {$line != ""}\
		{
			book_new_record $org_id $proj_id $book_id
			set fields [split $line $FIELD_SEPARATOR]
			set temp ""
			set fin ""
			foreach f $fields\
			{
				if {[cequal [cindex $f end] \\]}\
				{
					if {[clength $f] > 1}\
					{
						append temp [crange $f 0 end-1]$FIELD_SEPARATOR
					}\
					else\
					{
						append temp $FIELD_SEPARATOR
					}
				}\
				else\
				{
					set temp $temp$f
					lappend fin $temp
					set temp ""
				}
			}
			set fields $fin
			set i 0
			foreach f [keylkeys BOOK_FIELD] \
			{
				.r.book.v.$f.e insert 1.0 [lindex $fields $i]
				incr i
			}
		}
	}
	book_save_record $org_id $proj_id $book_id
	o_idle
}

proc book_d_import {org_id proj_id book_id}\
{
	global FILENAME FIELD_SEPARATOR fbe 
	catch {destroy .file}
	toplevel .file
	wm title .file "Import data"
	wm geometry .file 250x280+100+50
	filebrowser .file.fb 
	pack .file.fb
		.file.fb addlistbox .* -selectmode single
		.file.fb addlabel -text "Import: "
		.file.fb adddirlabel
		set fbe [.file.fb addentry -width 20]
		.file.fb addbutton -text OK -width 10 \
			-command "
				set FILENAME \[$fbe get\]
				set FIELD_SEPARATOR \[.file.fs.e get 1.0 end\]
				if {\$FILENAME != \"\"}\
				{
					destroy .file
					book_import $org_id $proj_id $book_id
				}
			"
		.file.fb addbutton -text Cancel -width 10 \
			-command "destroy .file"
		.file.fb readdir [pwd] .*
	frame .file.fs
	pack .file.fs -fill x -side top
		label .file.fs.lb -text "Field separator: "
		pack .file.fs.lb -side left
		text .file.fs.e -width 8 -height 1
		pack .file.fs.e -side left
	.file.fs.e insert 1.0 $FIELD_SEPARATOR
	focus $fbe
}

proc book_save {org_id proj_id book_id {save 1}}\
{
	global ORG_PATH
	upvar #0 BOOK_${org_id}_${proj_id}_${book_id} BOOK
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	if {$save == 1}\
	{
		catch {book_save_record $org_id $proj_id $book_id}
	}
	set ct [catch {
		set F [open $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}.tmp w+]
	} errmsg]
	if {$ct > 0}\
	{
		myError $errmsg
		return
	}
	set ct [catch {
	puts $F "set BOOK_${org_id}_${proj_id}_${book_id} \"\""
	puts $F "\n# STRUCTURE"
	puts $F "keylset BOOK_${org_id}_${proj_id}_${book_id} name [list [keylget BOOK name]]"
	puts $F "\n# FIELDS"
	puts $F "set BOOK_FIELD_${org_id}_${proj_id}_${book_id} \"\""
	foreach i [keylkeys BOOK_FIELD] \
	{
		puts $F "keylset BOOK_FIELD_${org_id}_${proj_id}_${book_id} $i.name [list [keylget BOOK_FIELD $i.name]]"
	}
	puts $F "\n# RECORDS"
	puts $F "set BOOK_REC_${org_id}_${proj_id}_${book_id} \"\""
	foreach i [keylkeys BOOK_REC] \
	{
		puts $F "keylset BOOK_REC_${org_id}_${proj_id}_${book_id} $i [list [keylget BOOK_REC $i]]"
	}
	close $F
	} errmsg]
	if {$ct > 0}\
	{
		unlink $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}.tmp
		myError "Cannot save book. Reason:\n$errmsg"
	}\
	else\
	{
		frename $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}.tmp $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}
		chmod 0600 $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}
	}
}

proc book_export_records {org_id proj_id book_id}\
{
	upvar #0 BOOK_${org_id}_${proj_id}_${book_id} BOOK
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	global FILENAME BOOK_SORT_LIST FIELD_SEPARATOR
	o_wait
	if {$FIELD_SEPARATOR == ""}\
	{
		set FIELD_SEPARATOR "	"
	}
	set FIELD_SEPARATOR [cindex $FIELD_SEPARATOR 0]
	book_save $org_id $proj_id $book_id
	set ct [catch {
		set F [open [pwd]/$FILENAME w+]
	} errmsg]
	if {$ct > 0}\
	{
		myError "Cannot save the book as records. Reason:\n$errmsg"
		return
	}
	foreach i $BOOK_SORT_LIST \
	{
		set line ""
		foreach f [keylkeys BOOK_REC $i] \
		{
			regsub -all $FIELD_SEPARATOR [keylget BOOK_REC $i.$f] "\\$FIELD_SEPARATOR" val
			append line $val$FIELD_SEPARATOR
		}
		puts $F "$line"
	}
	close $F
	o_idle
}

proc book_export_ascii {org_id proj_id book_id}\
{
	upvar #0 BOOK_${org_id}_${proj_id}_${book_id} BOOK
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	global FILENAME BOOK_SORT_LIST
	o_wait
	book_save $org_id $proj_id $book_id
	set ct [catch {
		set F [open [pwd]/$FILENAME w+]
	} errmsg]
	if {$ct > 0}\
	{
		myError "Cannot save the book as ascii. Reason:\n$errmsg"
		return
	}
	puts $F "[keylget BOOK name]\n"
	puts $F "+---------------+------------------------------------------------------------+"
	foreach i $BOOK_SORT_LIST \
	{
		foreach f [keylkeys BOOK_REC $i] \
		{
			set line [format "|%15.15s|%-60.60s|" [keylget BOOK_FIELD $f.name] [keylget BOOK_REC $i.$f]]
			puts $F "$line"
		}
		puts $F "+---------------+------------------------------------------------------------+"
	}
	close $F
	o_idle
}

proc book_export_html {org_id proj_id book_id}\
{
	upvar #0 BOOK_${org_id}_${proj_id}_${book_id} BOOK
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	global FILENAME BOOK_SORT_LIST
	o_wait
	if {[file extension $FILENAME] != ".html"}\
	{
		append FILENAME ".html"
	}
	set ct [catch {
		set F [open [pwd]/$FILENAME w+]
	} errmsg]
	if {$ct > 0}\
	{
		myError "Cannot save the book as html. Reason:\n$errmsg"
		return
	}
	book_save $org_id $proj_id $book_id
	puts $F "<html><head>"
	puts $F "<title>[html_text2html [keylget BOOK name]]</title>"
	puts $F "</head>"
	puts $F "<body bgcolor=\"#FFFFFF\">"
	puts $F "<h2>[html_text2html [keylget BOOK name]]</h2>"
	puts $F "<table>"
	foreach i $BOOK_SORT_LIST \
	{
		foreach f [keylkeys BOOK_REC $i] \
		{
			puts $F "\t<tr><td><b>[html_text2html [keylget BOOK_FIELD $f.name]]</b></td><td>[html_text2html [keylget BOOK_REC $i.$f]]</td></tr>"
		}
		puts $F "\t<tr colspan=2><td><hr></td></tr>"
	}
	puts $F "</table>"
	puts $F "</body></html>"
	close $F
	o_idle
}

proc book_d_export {org_id proj_id book_id mode}\
{
	global FILENAME FIELD_SEPARATOR fbe 
	catch {destroy .file}
	toplevel .file
	wm title .file "Export book - $mode"
	if {$mode == "records"}\
	{
		wm geometry .file 250x280+100+50
	}\
	else\
	{
		wm geometry .file 250x250+100+50
	}
	filebrowser .file.fb 
	pack .file.fb
		if {$mode == "html"}\
		{
			.file.fb addlistbox .*.html -selectmode single
		}\
		else\
		{
			.file.fb addlistbox .* -selectmode single
		}
		.file.fb addlabel -text "Export: "
		.file.fb adddirlabel
		set fbe [.file.fb addentry -width 20]
		.file.fb addbutton -text OK -width 10 \
			-command "
				set FILENAME \[$fbe get\]
				catch {set FIELD_SEPARATOR \[.file.fs.e get 1.0 end\]}
				if {\$FILENAME != \"\"}\
				{
					destroy .file
					book_export_$mode $org_id $proj_id $book_id
				}
			"
		.file.fb addbutton -text Cancel -width 10 \
			-command "destroy .file"
		if {$mode == "html"}\
		{
			.file.fb readdir [pwd] .*.html
		}\
		else\
		{
			.file.fb readdir [pwd] .*
		}
	if {$mode == "records"}\
	{
		frame .file.fs
		pack .file.fs -fill x -side top
			label .file.fs.lb -text "Field separator: "
			pack .file.fs.lb -side left
			text .file.fs.e -width 8 -height 1
			pack .file.fs.e -side left
		.file.fs.e insert 1.0 $FIELD_SEPARATOR
	}
	focus $fbe
}

proc book_delete {org_id proj_id book_id}\
{
	global ORG_PATH LIST_BOOK CUR_BOOK CUR_TYPE
	global BOOK_${org_id}_${proj_id}_${book_id}
	global BOOK_FIELD_${org_id}_${proj_id}_${book_id}
	global BOOK_REC_${org_id}_${proj_id}_${book_id}
	global confirm
	gen_d_yn_confirm "Do you really want to delete \"[keylget BOOK_${org_id}_${proj_id}_${book_id} name]\"?"
	tkwait variable confirm
	if {$confirm == "yes"}\
	{
		unlink $ORG_PATH/org_${org_id}/proj_${org_id}_${proj_id}/book_${org_id}_${proj_id}_${book_id}
		unset BOOK_${org_id}_${proj_id}_${book_id}
		unset BOOK_FIELD_${org_id}_${proj_id}_${book_id}
		unset BOOK_REC_${org_id}_${proj_id}_${book_id}
		set LIST_BOOK [lindex [intersect3 $LIST_BOOK ${org_id}_${proj_id}_${book_id}] 0]
		o_menu_compose $org_id
		set CUR_TYPE proj
		o_display_proj $org_id $proj_id
	}
}

##############################

proc book_sort_list {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	global BOOK_SORT_LIST BOOK_SORT
	o_wait
	set BOOK_SORT_LIST [lsort -command "book_sort $org_id $proj_id $book_id $BOOK_SORT" [keylkeys BOOK_REC]]
	o_idle
}

proc book_sort {org_id proj_id book_id field id1 id2}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	if {$field == "id"}\
	{
		if {$id1 > $id2}\
		{
			return 1
		}\
		elseif {$id1 < $id2}\
		{
			return -1
		}\
		else\
		{
			return 0
		}
	}\
	else\
	{
		return [ccollate [keylget BOOK_REC $id1.$field] [keylget BOOK_REC $id2.$field]]
	}
}

proc book_first_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	upvar #0 TOT_NUM_${org_id}_${proj_id}_${book_id} TOT_NUM
	global BOOK_SORT_LIST
	book_save_record $org_id $proj_id $book_id
	set CUR_NUM 1
	set TOT_NUM [llength [keylkeys BOOK_REC]]
	book_set_data $org_id $proj_id $book_id [lindex $BOOK_SORT_LIST 0]
}

proc book_prev_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	global BOOK_SORT_LIST
	book_save_record $org_id $proj_id $book_id
	if {$CUR_NUM > 1}\
	{
		incr CUR_NUM -1
	}
	book_set_data $org_id $proj_id $book_id [lindex $BOOK_SORT_LIST [expr $CUR_NUM - 1]]
}

proc book_next_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	global BOOK_SORT_LIST
	book_save_record $org_id $proj_id $book_id
	if {$CUR_NUM < [llength [keylkeys BOOK_REC]]}\
	{
		incr CUR_NUM 
	}
	book_set_data $org_id $proj_id $book_id [lindex $BOOK_SORT_LIST [expr $CUR_NUM - 1]]
}

proc book_last_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	global BOOK_SORT_LIST
	book_save_record $org_id $proj_id $book_id
	set CUR_NUM [llength [keylkeys BOOK_REC]]
	book_set_data $org_id $proj_id $book_id [lindex $BOOK_SORT_LIST end]
}

proc book_save_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	foreach i [keylkeys BOOK_FIELD] \
	{
		keylset BOOK_REC $CUR_ID.$i [lindex [split [.r.book.v.$i.e get 1.0 end] "\n"] 0]
	}
}

proc book_set_data {org_id proj_id book_id id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	set CUR_ID $id
	foreach i [keylkeys BOOK_FIELD] \
	{
		.r.book.v.$i.e delete 1.0 end
		if {[keylget BOOK_REC $id.$i {}]}\
		{
			.r.book.v.$i.e insert 1.0 "[keylget BOOK_REC $id.$i]"
		}
	}
}

proc book_clear_fields {org_id proj_id book_id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	foreach i [keylkeys BOOK_FIELD] \
	{
		.r.book.v.$i.e delete 1.0 end
	}
}

proc book_new_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	upvar #0 TOT_NUM_${org_id}_${proj_id}_${book_id} TOT_NUM
	global BOOK_SORT_LIST
	book_save_record $org_id $proj_id $book_id
	set CUR_NUM [expr [llength [keylkeys BOOK_REC]] + 1]
	set CUR_ID [expr [lindex [lsort -integer [keylkeys BOOK_REC]] end] + 1]
	lappend BOOK_SORT_LIST $CUR_ID
	book_clear_fields $org_id $proj_id $book_id
	book_save_record $org_id $proj_id $book_id
	set TOT_NUM [llength [keylkeys BOOK_REC]]
}

proc book_del_record {org_id proj_id book_id}\
{
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	upvar #0 CUR_NUM_${org_id}_${proj_id}_${book_id} CUR_NUM
	upvar #0 TOT_NUM_${org_id}_${proj_id}_${book_id} TOT_NUM
	global BOOK_SORT_LIST
	foreach i [keylkeys BOOK_FIELD] \
	{
		if {[keylget BOOK_REC $CUR_ID.$i {}]}\
		{
			keyldel BOOK_REC $CUR_ID.$i
		}
	}
	book_clear_fields $org_id $proj_id $book_id
	lvarpop BOOK_SORT_LIST [expr $CUR_NUM-1]
	if {$CUR_NUM > [llength [keylkeys BOOK_REC]] && $CUR_NUM > 1}\
	{
		set CUR_NUM [llength [keylkeys BOOK_REC]]
	}
	if {[llength [keylkeys BOOK_REC]] > 0}\
	{
		book_set_data $org_id $proj_id $book_id [lindex $BOOK_SORT_LIST [expr $CUR_NUM - 1]]
		set TOT_NUM [llength [keylkeys BOOK_REC]]
	}\
	else\
	{
		set BOOK_SORT_LIST 1
		set CUR_ID 1
		set CUR_NUM 1
		set TOT_NUM 1
		book_save_record $org_id $proj_id $book_id
	}
}

#############################

proc book_del_field {org_id proj_id book_id id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	keyldel BOOK_FIELD $id
	foreach i [keylkeys BOOK_REC]\
	{
		keyldel BOOK_REC $i.$id
	}
	destroy .r.book.v.$id
	book_set_data $org_id $proj_id $book_id $CUR_ID
}

proc book_d_ask_name {org_id proj_id book_id id}\
{
	upvar #0 BOOK_${org_id}_${proj_id}_${book_id} BOOK
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	global name
	catch {destroy .ask}
	toplevel .ask
	wm title .ask "Field name"
	wm geometry .ask +100+100
	text .ask.name -width 30 -height 1 -wrap word
	pack .ask.name -side top -fill x -anchor w
	frame .ask.b
	pack .ask.b -side bottom
		button .ask.b.ok -text Ok -width 10 \
			-command {
				if {[.ask.name get 1.0 end-1c] != ""}\
				{
					set name "[.ask.name get 1.0 end-1c]"
					destroy .ask
				}\
				else\
				{
					myError "The name of the field must not be empty."
				}
			}
		pack .ask.b.ok -side left
		button .ask.b.cancel -text Cancel -width 10
		pack .ask.b.cancel -side left
		button .ask.b.del -text Delete -width 10 \
			-command "
				set name \"\"
				book_del_field $org_id $proj_id $book_id $id
				destroy .ask
			"
		pack .ask.b.del -side left
	if {[llength [keylkeys BOOK_FIELD]] <= 1}\
	{
		.ask.b.del configure -state disabled
	}
	if {[keylget BOOK_FIELD $id.name {}]}\
	{
		.ask.name insert 1.0 "[keylget BOOK_FIELD $id.name]"
		.ask.b.cancel configure -command "
			set name [list [keylget BOOK_FIELD $id.name]]
			destroy .ask
		"
	}\
	else\
	{
		.ask.b.cancel configure -command "
			set name \"\"
			destroy .ask
		"
	}
	focus .ask.name
}

proc book_popup_name {org_id proj_id book_id id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	global name
	book_d_ask_name $org_id $proj_id $book_id $id
	tkwait variable name
	if {! [keylget BOOK_FIELD $id {}]}\
	{
		return
	}
	keylset BOOK_FIELD $id.name "$name"
	.r.book.v.$id.l configure -state normal
	.r.book.v.$id.l delete 0 end
	.r.book.v.$id.l insert 0 "[keylget BOOK_FIELD $id.name]"
	.r.book.v.$id.l configure -state disabled
	book_set_data $org_id $proj_id $book_id $CUR_ID
}

proc book_new_field {org_id proj_id book_id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	upvar #0 BOOK_REC_${org_id}_${proj_id}_${book_id} BOOK_REC
	upvar #0 CUR_ID_${org_id}_${proj_id}_${book_id} CUR_ID
	global BOOK_SORT
	set f [lindex [lsort [keylkeys BOOK_FIELD]] end]
	set f f[expr [crange $f 1 end] + 1]
	keylset BOOK_FIELD $f.name {New field}
	foreach i [keylkeys BOOK_REC]\
	{
		keylset BOOK_REC $i.$f {}
	}
	frame .r.book.v.$f
	pack .r.book.v.$f -side top -fill x
		entry .r.book.v.$f.l -width 17 -relief flat -background #EEEEEE -justify right
		pack .r.book.v.$f.l -side left -anchor w
		.r.book.v.$f.l delete 0 end
		.r.book.v.$f.l insert 0 "[keylget BOOK_FIELD $f.name] " 
		.r.book.v.$f.l configure -state disabled
		bind .r.book.v.$f.l <1> "
			book_popup_name $org_id $proj_id $book_id $f
			break
		"
		radiobutton .r.book.v.$f.r -variable BOOK_SORT -value $f \
			-takefocus 0 \
			-command "
				book_sort_list $org_id $proj_id $book_id
				book_first_record $org_id $proj_id $book_id
			"
		pack .r.book.v.$f.r -side left
		text .r.book.v.$f.e -width 100 -height 1
		pack .r.book.v.$f.e -side left
	book_set_data $org_id $proj_id $book_id $CUR_ID
}

proc book_draw_fields {org_id proj_id book_id}\
{
	upvar #0 BOOK_FIELD_${org_id}_${proj_id}_${book_id} BOOK_FIELD
	global BOOK_SORT
	catch {destroy .r.book.v}
	frame .r.book.v 
	pack .r.book.v -side top -fill both
	foreach i [keylkeys BOOK_FIELD] \
	{
		frame .r.book.v.$i
		pack .r.book.v.$i -side top -fill x
			entry .r.book.v.$i.l -width 17 -relief flat -background #EEEEEE -justify right
			pack .r.book.v.$i.l -side left -anchor w
			.r.book.v.$i.l delete 0 end
			.r.book.v.$i.l insert 0 "[keylget BOOK_FIELD $i.name] " 
			.r.book.v.$i.l configure -state disabled
			bind .r.book.v.$i.l <1> "
				book_popup_name $org_id $proj_id $book_id $i 
				break
			"
			radiobutton .r.book.v.$i.r -variable BOOK_SORT -value $i \
				-takefocus 0 \
				-command "
					book_sort_list $org_id $proj_id $book_id
					book_first_record $org_id $proj_id $book_id
				"
			pack .r.book.v.$i.r -side left
			text .r.book.v.$i.e -width 100 -height 1
			pack .r.book.v.$i.e -side left
	}
}

#############################

